Bug 1375465 - [RFE] Implement multi threaded self-heal for ec volumes
Summary: [RFE] Implement multi threaded self-heal for ec volumes
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: disperse
Version: rhgs-3.1
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
: RHGS 3.2.0
Assignee: Pranith Kumar K
QA Contact: nchilaka
URL:
Whiteboard:
Depends On: 1368451
Blocks: 1351503
TreeView+ depends on / blocked
 
Reported: 2016-09-13 08:27 UTC by Atin Mukherjee
Modified: 2017-03-23 05:47 UTC (History)
8 users (show)

Fixed In Version: glusterfs-3.8.4-3
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1368451
Environment:
Last Closed: 2017-03-23 05:47:10 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:0486 normal SHIPPED_LIVE Moderate: Red Hat Gluster Storage 3.2.0 security, bug fix, and enhancement update 2017-03-23 09:18:45 UTC

Description Atin Mukherjee 2016-09-13 08:27:49 UTC
+++ This bug was initially created as a clone of Bug #1368451 +++

Description of problem:
We need a way to increase parallelism in number of heals that can happen in disperse volumes as well. This bug tracks that RFE

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

--- Additional comment from Vijay Bellur on 2016-08-19 10:06:55 EDT ---

REVIEW: http://review.gluster.org/15083 (cluster/ec: Do multi-threaded self-heal) posted (#2) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)

--- Additional comment from Worker Ant on 2016-08-24 13:21:08 EDT ---

REVIEW: http://review.gluster.org/15083 (cluster/ec: Do multi-threaded self-heal) posted (#3) for review on master by Pranith Kumar Karampuri (pkarampu@redhat.com)

--- Additional comment from Worker Ant on 2016-08-24 18:24:26 EDT ---

COMMIT: http://review.gluster.org/15083 committed in master by Pranith Kumar Karampuri (pkarampu@redhat.com) 
------
commit 56a79b357e09d91305994fcc0b2d250cb9ac243d
Author: Pranith Kumar K <pkarampu@redhat.com>
Date:   Thu Aug 4 00:41:16 2016 +0530

    cluster/ec: Do multi-threaded self-heal
    
    BUG: 1368451
    Change-Id: I5d6b91d714ad6906dc478a401e614115c89a8fbb
    Signed-off-by: Pranith Kumar K <pkarampu@redhat.com>
    Reviewed-on: http://review.gluster.org/15083
    Smoke: Gluster Build System <jenkins@build.gluster.org>
    Reviewed-by: Ashish Pandey <aspandey@redhat.com>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.org>

Comment 5 nchilaka 2016-11-15 11:27:07 UTC
QATP:
=====
1)
1) Create 4+2 volume.
2) Kill a brick process from the server.
3) Start IO using dd with creating multiple small files in thousands
4) Open the log files on all the bricks 
5) start the brick force by gluster volume <vol-name> start force
6) logs should show healing in parallel

Expected :-
Check for the threads in TOP command.
Heals should be done. from source brick to empty brick.
Threads should work parallel and heal files 


2)
Summary:- Healing with single thread and Multithread.
Note turn of metadata , entry and data heal and self heal daemon.
1) Create single 4+2 volume on two setups.
2) Change the "cluster.shd-max-threads" to default on one setup and 16 to second setup.
3) Kill one of the brick process and create same mulitple files and folders on the two volumes
4) Now start the metadata , entry and data heal and self heal daemon and the brick process.
5) Calculate the time for both the volumes, Mulithreaded volume should heal faster.
6) check logs for heal progress.


Expected:-
Mulitthreaded heal should be done faster.
No heal should fail.

Comment 6 nchilaka 2016-11-15 11:28:16 UTC
verfied mtsh for ec volume and I see that parallel heals are happening to improve performance.

Moving to verified.

Will raise new bugs if any on this seperately

verified version:3.8.4-5

Comment 8 errata-xmlrpc 2017-03-23 05:47:10 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2017-0486.html


Note You need to log in before you can comment on or make changes to this bug.